//---------------------------------------------------------------------------
//
//  U3_EFunctions.cs
// 
//  Demonstrates the UD E-functions with the LabJack U3.  For timer/counter
//  testing, connect FIO4 to FIO5 and FIO6.
//
//  support@labjack.com
//  March 12, 201
//----------------------------------------------------------------------
//


using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using LabJack.LabJackUD; 

namespace U3_EFunctionsForm
{

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class U3_EFunctions : System.Windows.Forms.Form
	{

		private U3 u3;

		private System.Windows.Forms.Label ainThreeLabel;
		private System.Windows.Forms.Label dacZeroLabel;
		private System.Windows.Forms.Label fioFourLabel;
		private System.Windows.Forms.Label fioSevenLabel;
		private System.Windows.Forms.Label timerOneLabel;
		private System.Windows.Forms.Label counterOneLabel;
		private System.Windows.Forms.Label highClicksOneLabel;
		private System.Windows.Forms.Label lowClicksOneLabel;
		private System.Windows.Forms.Label dutyCycleOneLabel;
		private System.Windows.Forms.Button goButton;
		internal System.Windows.Forms.Label dutyCycleOneDisplay;
		internal System.Windows.Forms.Label lowClicksOneDisplay;
		internal System.Windows.Forms.Label highClicksOneDisplay;
		internal System.Windows.Forms.Label counterOneDisplay;
		internal System.Windows.Forms.Label timerOneDisplay;
		internal System.Windows.Forms.Label fioSevenDisplay;
		internal System.Windows.Forms.Label fioFourDisplay;
		internal System.Windows.Forms.Label dacZeroDisplay;
		internal System.Windows.Forms.Label ainThreeDisplay;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public U3_EFunctions()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.ainThreeLabel = new System.Windows.Forms.Label();
			this.dacZeroLabel = new System.Windows.Forms.Label();
			this.fioFourLabel = new System.Windows.Forms.Label();
			this.fioSevenLabel = new System.Windows.Forms.Label();
			this.timerOneLabel = new System.Windows.Forms.Label();
			this.counterOneLabel = new System.Windows.Forms.Label();
			this.highClicksOneLabel = new System.Windows.Forms.Label();
			this.lowClicksOneLabel = new System.Windows.Forms.Label();
			this.dutyCycleOneLabel = new System.Windows.Forms.Label();
			this.goButton = new System.Windows.Forms.Button();
			this.dutyCycleOneDisplay = new System.Windows.Forms.Label();
			this.lowClicksOneDisplay = new System.Windows.Forms.Label();
			this.highClicksOneDisplay = new System.Windows.Forms.Label();
			this.counterOneDisplay = new System.Windows.Forms.Label();
			this.timerOneDisplay = new System.Windows.Forms.Label();
			this.fioSevenDisplay = new System.Windows.Forms.Label();
			this.fioFourDisplay = new System.Windows.Forms.Label();
			this.dacZeroDisplay = new System.Windows.Forms.Label();
			this.ainThreeDisplay = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// ainThreeLabel
			// 
			this.ainThreeLabel.Location = new System.Drawing.Point(8, 8);
			this.ainThreeLabel.Name = "ainThreeLabel";
			this.ainThreeLabel.Size = new System.Drawing.Size(128, 16);
			this.ainThreeLabel.TabIndex = 0;
			this.ainThreeLabel.Text = "AIN3: ";
			// 
			// dacZeroLabel
			// 
			this.dacZeroLabel.Location = new System.Drawing.Point(8, 32);
			this.dacZeroLabel.Name = "dacZeroLabel";
			this.dacZeroLabel.Size = new System.Drawing.Size(128, 16);
			this.dacZeroLabel.TabIndex = 2;
			this.dacZeroLabel.Text = "DAC0: ";
			// 
			// fioFourLabel
			// 
			this.fioFourLabel.Location = new System.Drawing.Point(8, 56);
			this.fioFourLabel.Name = "fioFourLabel";
			this.fioFourLabel.Size = new System.Drawing.Size(128, 16);
			this.fioFourLabel.TabIndex = 4;
			this.fioFourLabel.Text = "FIO4: ";
			// 
			// fioSevenLabel
			// 
			this.fioSevenLabel.Location = new System.Drawing.Point(8, 80);
			this.fioSevenLabel.Name = "fioSevenLabel";
			this.fioSevenLabel.Size = new System.Drawing.Size(128, 16);
			this.fioSevenLabel.TabIndex = 5;
			this.fioSevenLabel.Text = "FIO7:";
			// 
			// timerOneLabel
			// 
			this.timerOneLabel.Location = new System.Drawing.Point(8, 104);
			this.timerOneLabel.Name = "timerOneLabel";
			this.timerOneLabel.Size = new System.Drawing.Size(128, 16);
			this.timerOneLabel.TabIndex = 6;
			this.timerOneLabel.Text = "Timer 1:";
			// 
			// counterOneLabel
			// 
			this.counterOneLabel.Location = new System.Drawing.Point(8, 128);
			this.counterOneLabel.Name = "counterOneLabel";
			this.counterOneLabel.Size = new System.Drawing.Size(128, 16);
			this.counterOneLabel.TabIndex = 7;
			this.counterOneLabel.Text = "Counter 1:";
			// 
			// highClicksOneLabel
			// 
			this.highClicksOneLabel.Location = new System.Drawing.Point(8, 152);
			this.highClicksOneLabel.Name = "highClicksOneLabel";
			this.highClicksOneLabel.Size = new System.Drawing.Size(128, 16);
			this.highClicksOneLabel.TabIndex = 8;
			this.highClicksOneLabel.Text = "High clicks Timer 1:";
			// 
			// lowClicksOneLabel
			// 
			this.lowClicksOneLabel.Location = new System.Drawing.Point(8, 176);
			this.lowClicksOneLabel.Name = "lowClicksOneLabel";
			this.lowClicksOneLabel.Size = new System.Drawing.Size(128, 16);
			this.lowClicksOneLabel.TabIndex = 9;
			this.lowClicksOneLabel.Text = "Low clicks Timer 1:";
			// 
			// dutyCycleOneLabel
			// 
			this.dutyCycleOneLabel.Location = new System.Drawing.Point(8, 200);
			this.dutyCycleOneLabel.Name = "dutyCycleOneLabel";
			this.dutyCycleOneLabel.Size = new System.Drawing.Size(128, 16);
			this.dutyCycleOneLabel.TabIndex = 10;
			this.dutyCycleOneLabel.Text = "Duty cycle Timer 1:";
			// 
			// goButton
			// 
			this.goButton.Location = new System.Drawing.Point(8, 232);
			this.goButton.Name = "goButton";
			this.goButton.Size = new System.Drawing.Size(272, 24);
			this.goButton.TabIndex = 11;
			this.goButton.Text = "Go";
			this.goButton.Click += new System.EventHandler(this.button1_Click);
			// 
			// dutyCycleOneDisplay
			// 
			this.dutyCycleOneDisplay.Location = new System.Drawing.Point(152, 200);
			this.dutyCycleOneDisplay.Name = "dutyCycleOneDisplay";
			this.dutyCycleOneDisplay.Size = new System.Drawing.Size(136, 16);
			this.dutyCycleOneDisplay.TabIndex = 26;
			// 
			// lowClicksOneDisplay
			// 
			this.lowClicksOneDisplay.Location = new System.Drawing.Point(152, 176);
			this.lowClicksOneDisplay.Name = "lowClicksOneDisplay";
			this.lowClicksOneDisplay.Size = new System.Drawing.Size(136, 16);
			this.lowClicksOneDisplay.TabIndex = 25;
			// 
			// highClicksOneDisplay
			// 
			this.highClicksOneDisplay.Location = new System.Drawing.Point(152, 152);
			this.highClicksOneDisplay.Name = "highClicksOneDisplay";
			this.highClicksOneDisplay.Size = new System.Drawing.Size(136, 16);
			this.highClicksOneDisplay.TabIndex = 24;
			// 
			// counterOneDisplay
			// 
			this.counterOneDisplay.Location = new System.Drawing.Point(152, 128);
			this.counterOneDisplay.Name = "counterOneDisplay";
			this.counterOneDisplay.Size = new System.Drawing.Size(136, 16);
			this.counterOneDisplay.TabIndex = 23;
			// 
			// timerOneDisplay
			// 
			this.timerOneDisplay.Location = new System.Drawing.Point(152, 104);
			this.timerOneDisplay.Name = "timerOneDisplay";
			this.timerOneDisplay.Size = new System.Drawing.Size(136, 16);
			this.timerOneDisplay.TabIndex = 22;
			// 
			// fioSevenDisplay
			// 
			this.fioSevenDisplay.Location = new System.Drawing.Point(152, 80);
			this.fioSevenDisplay.Name = "fioSevenDisplay";
			this.fioSevenDisplay.Size = new System.Drawing.Size(136, 16);
			this.fioSevenDisplay.TabIndex = 21;
			// 
			// fioFourDisplay
			// 
			this.fioFourDisplay.Location = new System.Drawing.Point(152, 56);
			this.fioFourDisplay.Name = "fioFourDisplay";
			this.fioFourDisplay.Size = new System.Drawing.Size(136, 16);
			this.fioFourDisplay.TabIndex = 20;
			// 
			// dacZeroDisplay
			// 
			this.dacZeroDisplay.Location = new System.Drawing.Point(152, 32);
			this.dacZeroDisplay.Name = "dacZeroDisplay";
			this.dacZeroDisplay.Size = new System.Drawing.Size(136, 16);
			this.dacZeroDisplay.TabIndex = 19;
			// 
			// ainThreeDisplay
			// 
			this.ainThreeDisplay.Location = new System.Drawing.Point(152, 8);
			this.ainThreeDisplay.Name = "ainThreeDisplay";
			this.ainThreeDisplay.Size = new System.Drawing.Size(136, 16);
			this.ainThreeDisplay.TabIndex = 18;
			// 
			// U3_EFunctions
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.dutyCycleOneDisplay);
			this.Controls.Add(this.lowClicksOneDisplay);
			this.Controls.Add(this.highClicksOneDisplay);
			this.Controls.Add(this.counterOneDisplay);
			this.Controls.Add(this.timerOneDisplay);
			this.Controls.Add(this.fioSevenDisplay);
			this.Controls.Add(this.fioFourDisplay);
			this.Controls.Add(this.dacZeroDisplay);
			this.Controls.Add(this.ainThreeDisplay);
			this.Controls.Add(this.goButton);
			this.Controls.Add(this.dutyCycleOneLabel);
			this.Controls.Add(this.lowClicksOneLabel);
			this.Controls.Add(this.highClicksOneLabel);
			this.Controls.Add(this.counterOneLabel);
			this.Controls.Add(this.timerOneLabel);
			this.Controls.Add(this.fioSevenLabel);
			this.Controls.Add(this.fioFourLabel);
			this.Controls.Add(this.dacZeroLabel);
			this.Controls.Add(this.ainThreeLabel);
			this.Name = "U3_EFunctions";
			this.Text = "U3_EFunctions";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new U3_EFunctions());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			double dblValue=0;
			int intValue=0;

			int binary;
			int[] aEnableTimers = new int[2];
			int[] aEnableCounters = new int[2];
			int tcpInOffset;
			int timerClockDivisor;
			LJUD.TIMERCLOCKS timerClockBaseIndex;
			int[] aTimerModes = new int[2];
			double[] adblTimerValues = new double[2];
			int[] aReadTimers = new int[2];
			int[] aUpdateResetTimers = new int[2];
			int[] aReadCounters = new int[2];
			int[] aResetCounters = new int[2];
			double[] adblCounterValues = {0,0};
			double highTime, lowTime, dutyCycle;
			
			try 
			{
				//Open the first found LabJack U3.
				u3 = new U3(LJUD.CONNECTION.USB, "0", true); // Connection through USB
			
				//Start by using the pin_configuration_reset IOType so that all
				//pin assignments are in the factory default condition.
				LJUD.ePut (u3.ljhandle, LJUD.IO.PIN_CONFIGURATION_RESET, 0, 0, 0);

				//Take a single-ended measurement from AIN3.
				binary = 0;
				LJUD.eAIN( u3.ljhandle, 3, 31, ref dblValue, -1, -1, -1, binary);
				ainThreeDisplay.Text = dblValue.ToString();

				//Set DAC0 to 3.0 volts.
				dblValue = 3.0;
				binary = 0;
				LJUD.eDAC (u3.ljhandle, 0, dblValue, binary, 0, 0);
				dacZeroDisplay.Text = dblValue.ToString();

				//Read state of FIO4.
				LJUD.eDI (u3.ljhandle, 4, ref intValue);
				fioFourDisplay.Text = intValue.ToString();

				//Set the state of FIO7.
				intValue = 1;
				LJUD.eDO (u3.ljhandle, 7, intValue);
				fioSevenDisplay.Text = intValue.ToString();

				//Timers and Counters example.
				//First, a call to eTCConfig.  Fill the arrays with the desired values, then make the call.
				aEnableTimers[0] = 1; //Enable Timer0 (uses FIO4).
				aEnableTimers[1] = 1; //Enable Timer1 (uses FIO5).
				aEnableCounters[0] = 0; //Disable Counter0.
				aEnableCounters[1] = 1; //Enable Counter1 (uses FIO6).
				tcpInOffset = 4;  //Offset is 4, so timers/counters start at FIO4.
				timerClockBaseIndex = LJUD.TIMERCLOCKS.MHZ48_DIV;  //Base clock is 48 MHz with divisor support, so Counter0 is not available.
				//timerClockBaseIndex = LJUD.TIMERCLOCKS.MHZ24_DIV;  //Use this line instead for hardware rev 1.20.
				timerClockDivisor = 48; //Thus timer clock is 1 MHz.
				//timerClockDivisor = 24;  //Use this line instead for hardware rev 1.20.
				aTimerModes[0] = (int) LJUD.TIMERMODE.PWM8; //Timer0 is 8-bit PWM output.  Frequency is 1M/256 = 3906 Hz.
				aTimerModes[1] = (int) LJUD.TIMERMODE.DUTYCYCLE; //Timer1 is duty cyle input.
				adblTimerValues[0] = 16384; //Set PWM8 duty-cycle to 75%.
				adblTimerValues[1] = 0;
				LJUD.eTCConfig(u3.ljhandle, aEnableTimers, aEnableCounters, tcpInOffset, (int) timerClockBaseIndex, timerClockDivisor, aTimerModes, adblTimerValues, 0, 0);

				Thread.Sleep(1000); //Wait 1 second.

				//Now, a call to eTCValues.
				aReadTimers[0] = 0; //Don't read Timer0 (output timer).
				aReadTimers[1] = 1; //Read Timer1;
				aUpdateResetTimers[0] = 1; //Update Timer0;
				aUpdateResetTimers[1] = 1; //Reset Timer1;
				aReadCounters[0] = 0;
				aReadCounters[1] = 1; //Read Counter1;
				aResetCounters[0] = 0;
				aResetCounters[1] = 1; //Reset Counter1.
				adblTimerValues[0] = 32768; //Change Timer0 duty-cycle to 50%.
				adblTimerValues[1] = 0;
				LJUD.eTCValues(u3.ljhandle, aReadTimers, aUpdateResetTimers, aReadCounters, aResetCounters, adblTimerValues, adblCounterValues, 0, 0);
				timerOneDisplay.Text = adblTimerValues[1].ToString();
				counterOneDisplay.Text = adblCounterValues[1].ToString();

				//Convert Timer1 value to duty-cycle percentage.
				//High time is LSW
				highTime = (double)(((ulong)adblTimerValues[1]) % (65536));
				//Low time is MSW
				lowTime = (double)(((ulong)adblTimerValues[1]) / (65536));
				//Calculate the duty cycle percentage.
				dutyCycle = 100*highTime/(highTime+lowTime);
				highClicksOneDisplay.Text = highTime.ToString();
				lowClicksOneDisplay.Text = lowTime.ToString();
				dutyCycleOneDisplay.Text = dutyCycle.ToString();


				//Disable all timers and counters.
				aEnableTimers[0] = 0;
				aEnableTimers[1] = 0;
				aEnableCounters[0] = 0;
				aEnableCounters[1] = 0;
				LJUD.eTCConfig(u3.ljhandle, aEnableTimers, aEnableCounters, 4, (int)timerClockBaseIndex, timerClockDivisor, aTimerModes, adblTimerValues, 0, 0);
			}
			catch (LabJackUDException ex) 
			{
				showErrorMessage(ex);
			}
		}

		// If error occured print a message indicating which one occurred. If the error is a group error (communication/fatal), quit
		public void showErrorMessage(LabJackUDException e)
		{
			Console.Out.WriteLine("Error: " + e.ToString());
			if (e.LJUDError > U3.LJUDERROR.MIN_GROUP_ERROR)
			{
				Console.ReadLine(); // Pause for the user
				Environment.Exit(-1);
			}
		}
	}
}
